package fr.sanchezm.attestationsCovid19.data.db.dao

import androidx.lifecycle.LiveData
import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import fr.sanchezm.attestationsCovid19.data.db.entity.Attestation
import fr.sanchezm.attestationsCovid19.data.db.entity.CURRENT_ATTESTATION_ID
import fr.sanchezm.attestationsCovid19.data.db.entity.CURRENT_PROFILE_ID
import fr.sanchezm.attestationsCovid19.data.db.entity.Profile

@Dao
interface AttestationDao {
    @Insert
    fun insert(attestation: Attestation)

    @Query(value = "SELECT * FROM attestation WHERE id = $CURRENT_ATTESTATION_ID")
    fun getAttestation(): LiveData<Attestation>
}