package fr.sanchezm.attestationsCovid19.data.repository

import fr.sanchezm.attestationsCovid19.data.db.dao.AttestationDao
import fr.sanchezm.attestationsCovid19.data.db.dao.ProfileDao
import fr.sanchezm.attestationsCovid19.data.db.entity.Attestation
import fr.sanchezm.attestationsCovid19.data.db.entity.Profile

class AttestationRepository private constructor(private val attestationDao: AttestationDao) {

    fun getProfile() = attestationDao.getAttestation()

    fun insertProfile(attestation: Attestation) = attestationDao.insert(attestation)

    companion object {
        @Volatile
        private var instance: AttestationRepository? = null

        fun getInstance(attestationDao: AttestationDao) =
            instance ?: synchronized(this) {
                instance ?: AttestationRepository(attestationDao).also { instance = it }
            }
    }
}