package fr.sanchezm.attestationsCovid19.ui.add

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.lifecycle.ViewModelProvider
import fr.sanchezm.attestationsCovid19.R
import fr.sanchezm.attestationsCovid19.databinding.FragmentAddAttestationBinding
import fr.sanchezm.attestationsCovid19.utilities.InjectorUtils

class AddFragment : Fragment() {

    private lateinit var addViewModel: AddViewModel

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        initializeUi()
        val binding = DataBindingUtil.inflate<FragmentAddAttestationBinding>(
            inflater,
            R.layout.fragment_add_attestation,
            container,
            false
        ).apply {
            this.lifecycleOwner = this@AddFragment
            this.viewModel = addViewModel
        }

        return binding.root
    }

    private fun initializeUi() {
        val factory = context?.let { InjectorUtils.provideAddViewModelFactory(it) }
        addViewModel = factory?.let {
            ViewModelProvider(this, it)
                .get(AddViewModel::class.java)
        }!!
    }
}
