package fr.sanchezm.attestationsCovid19.utilities

import android.content.Context
import fr.sanchezm.attestationsCovid19.data.db.MyDatabase
import fr.sanchezm.attestationsCovid19.data.repository.AttestationRepository
import fr.sanchezm.attestationsCovid19.data.repository.ProfileRepository
import fr.sanchezm.attestationsCovid19.ui.add.AddViewModelFactory
import fr.sanchezm.attestationsCovid19.ui.attestations.AttestationsViewModel

object InjectorUtils {

    fun provideAddViewModelFactory(context: Context): AddViewModelFactory {
        val profileRepository =
            ProfileRepository.getInstance(MyDatabase.invoke(context).profileDao())

        return AddViewModelFactory(profileRepository = profileRepository)
    }

    fun provideAttestationViewModel(context: Context): AttestationsViewModel {
        val attestationRepository = AttestationRepository.getInstance(MyDatabase.invoke(context).attestationDao())
        return AttestationsViewModel(attestationRepository)
    }

}